/// <reference types="node" />
import * as net from 'net';
import * as http from 'http';
import { Log } from 'hurp-types';
export interface Options {
    tag?: string;
    log: Log;
    server?: http.Server;
    handler: (req: http.IncomingMessage, res: http.ServerResponse) => void;
    listen?: net.ListenOptions;
}
export default class HttpServer {
    private destroyed;
    private readonly connections;
    readonly tag: string;
    readonly log: Log;
    readonly server: http.Server;
    readonly listenOptions?: net.ListenOptions;
    constructor(options: Options);
    private trackConnection;
    private trackRequest;
    private destroyConnection;
    init(): Promise<void>;
    destroy(): Promise<void>;
}
